(define-module (ui quota ajax)
	       :use-module (alterator ajax)
	       :use-module (alterator algo)
	       :use-module (alterator woo)
	       :export (init))

(define (hack-type-to-string value)
  (if (string? value) value (if value "on" "off")))

(define (hack-type-to-bool value)
  (if (string? value) (string=? "on" value) value))

(define (ui-list)
  (let ((fs-list (woo-list "/quota/availablefs"))
	(uid-list (woo-list "/quota/users" )))

	(form-update-enum "fs" fs-list)
	(form-update-enum  "uid" uid-list)
	(if (pair? fs-list)
	  (form-update-value "fs" (woo-get-option (car fs-list) 'name)))
	(if (pair? uid-list)
	  (form-update-value "uid" (woo-get-option (car uid-list) 'name)))
	(ui-read)))

(define (ui-read)
  (catch/message
    (lambda()
      (let ((fs (form-value "fs"))
	    (uid (form-value "uid")))
	(and (string? fs)
	     (string? uid)
	     (form-update-value-list
	       `("fs" "uid" "b_used" "b_soft" "b_hard" "i_used" "i_soft" "i_hard")
	       (woo-read-first "/quota/quota" 'fs fs 'uid uid)))
	(and (string? fs)
	     (let ((dataenabled (woo-get-option (woo-read-first "/quota/fs" 'fs fs) 'enabled)))
	       (form-update-value "fsenabled" (hack-type-to-string dataenabled))
	       (form-update-activity `("uid" "b_soft" "b_hard" "i_soft" "i_hard" "apply_button" "reset_button") (hack-type-to-bool dataenabled))))))))

(define (ui-write)
  (catch/message
    (lambda()
      (apply woo-write "/quota/quota"
	     'language (form-value "language")
	     (form-value-list `("fs" "uid" "b_soft" "b_hard" "i_soft" "i_hard")))
      (ui-read))))

(define (ui-fsenabled-change)
  (catch/message
    (lambda()
      (woo-write "/quota/fs"
            'language (form-value "language")
            'fs (form-value "fs")
            'enabled (hack-type-to-bool (form-value "fsenabled")))))
      (ui-read))

(define (init)
  (ui-list)

  (form-bind "fs"  "change"  ui-read)
  (form-bind "uid" "change"  ui-read)
  (form-bind "fsenabled" "change"  ui-fsenabled-change)

  (form-bind "apply_button" "click" ui-write)
  (form-bind "reset_button" "click" ui-read))
