(document:surround "/std/frame")

(define (on-change-fs)
  (let ( (flist (woo-list "/quota/availablefs")) )

    (if (string= (form-value "fs") "")
      (form-update-value "fs" (woo-get-option (cond-car flist) 'name)))

    (let* ( (fs (form-value "fs"))
            (uid (form-value "uid"))
            (ulist (woo-list "/quota/users" 'fs fs))
            (enableddata (woo-read-first "/quota/fs" 'fs fs)) )

       (form-update-value "fsenabled" (woo-get-option enableddata 'enabled))
       (form-update-enum "uid" ulist)

       (form-update-value "uid"
         (if (string= uid "") (woo-get-option (cond-car ulist) 'name) uid)) )

    (update-effect)
    (on-change-user) ))

(define (on-change-user)
  (catch/message (lambda()
    (let ((fs (form-value "fs"))
          (uid (form-value "uid")) )
      (let ((data (woo-read-first "/quota/quota" 'fs fs 'uid uid)))
        (form-update-value "b_used" (woo-get-option data 'b_used))
        (form-update-value "b_soft" (woo-get-option data 'b_soft))
        (form-update-value "b_hard" (woo-get-option data 'b_hard))
        (form-update-value "i_used" (woo-get-option data 'i_used))
        (form-update-value "i_soft" (woo-get-option data 'i_soft))
        (form-update-value "i_hard" (woo-get-option data 'i_hard)) )))))

(define (on-change-fs-enabled)
  (update-effect)
  (catch/message (lambda()
    (woo-write "/quota/fs" 'fs (form-value "fs") 'enabled (form-value "fsenabled")) ))
    (on-change-user)
  )

(define (on-apply)
  (catch/message (lambda()
    (apply woo-write "/quota/quota" (form-value-list `("fs" "uid" "b_soft" "b_hard" "i_soft" "i_hard"))) )))

(define (ui-init)
  (effect-enable "uid" "fsenabled" #t)
  (effect-enable "b_soft" "fsenabled" #t)
  (effect-enable "b_hard" "fsenabled" #t)
  (effect-enable "i_soft" "fsenabled" #t)
  (effect-enable "i_hard" "fsenabled" #t)
  (effect-enable "apply_button" "fsenabled" #t)
  (effect-enable "reset_button" "fsenabled" #t)
  (on-change-fs))
;;

(gridbox columns "1;39;60" margin 20

 (label text (_ "Filesystem:") align "right")
 (combobox name "fs" enumref "/quota/availablefs" (when changed (on-change-fs)))
 (checkbox text (_ "Enabled") name "fsenabled" (when changed (on-change-fs-enabled)))

 (label name "uid" text (_ "User:") align "right;top")
 (listbox name "uid" enumref "/quota/users" (when changed (on-change-user)))

 (gridbox columns "1;90;10" margin 20

   (label name "b_used" text (_ "Used disk space:") align "right")
   (edit  name "b_used" activity #f)
   (label name "b_used" text (_ "kb"))

   (label name "b_soft" text (_ "Soft limit:") align "right")
   (edit  name "b_soft")
   (label name "b_soft" text (_ "kb"))

   (label name "b_hard" text (_ "Hard limit:") align "right")
   (edit  name "b_hard")
   (label name "b_hard" text (_ "kb"))

   (label name "i_used" text (_ "Inodes used:") align "right")
   (edit  name "i_used" activity #f)
   (spacer)

   (label name "i_soft" text (_ "Soft limit:") align "right")
   (edit  name "i_soft")
   (spacer)

   (label name "i_hard" text (_ "Hard limit:") align "right")
   (edit  name "i_hard")
   (spacer)

   (spacer)
   (button name "apply_button" text (_ "Apply") (when clicked (on-apply)))
   (button name "reset_button" text (_ "Reset") (when clicked (on-change-user)))
 )
)
(document:root (when loaded (ui-init) ))
